/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "detalle_ajuste")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "DetalleAjuste.findAll", query = "SELECT d FROM DetalleAjuste d"),
        @NamedQuery(name = "DetalleAjuste.findByAjusteCodigo", query = "SELECT d FROM DetalleAjuste d WHERE d.detalleAjustePK.ajusteCodigo = :ajusteCodigo"),
        @NamedQuery(name = "DetalleAjuste.findByProductoCodigo", query = "SELECT d FROM DetalleAjuste d WHERE d.detalleAjustePK.productoCodigo = :productoCodigo"),
        @NamedQuery(name = "DetalleAjuste.findByDetalleAjusteCantidad", query = "SELECT d FROM DetalleAjuste d WHERE d.detalleAjusteCantidad = :detalleAjusteCantidad"),
        @NamedQuery(name = "DetalleAjuste.findByDetalleAjustePrecio", query = "SELECT d FROM DetalleAjuste d WHERE d.detalleAjustePrecio = :detalleAjustePrecio"),
        @NamedQuery(name = "DetalleAjuste.findByDetalleAjusteTipo", query = "SELECT d FROM DetalleAjuste d WHERE d.detalleAjusteTipo = :detalleAjusteTipo")})
public class DetalleAjuste implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected DetalleAjustePK detalleAjustePK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "detalle_ajuste_cantidad")
    private int detalleAjusteCantidad;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Column(name = "detalle_ajuste_precio")
    private BigDecimal detalleAjustePrecio;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 10)
    @Column(name = "detalle_ajuste_tipo")
    private String detalleAjusteTipo;
    @JoinColumn(name = "ajuste_codigo", referencedColumnName = "ajuste_codigo", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Ajuste ajuste;

    public DetalleAjuste() {
    }

    public DetalleAjuste(DetalleAjustePK detalleAjustePK) {
        this.detalleAjustePK = detalleAjustePK;
    }

    public DetalleAjuste(DetalleAjustePK detalleAjustePK, int detalleAjusteCantidad, BigDecimal detalleAjustePrecio, String detalleAjusteTipo) {
        this.detalleAjustePK = detalleAjustePK;
        this.detalleAjusteCantidad = detalleAjusteCantidad;
        this.detalleAjustePrecio = detalleAjustePrecio;
        this.detalleAjusteTipo = detalleAjusteTipo;
    }

    public DetalleAjuste(String ajusteCodigo, String productoCodigo) {
        this.detalleAjustePK = new DetalleAjustePK(ajusteCodigo, productoCodigo);
    }

    public DetalleAjustePK getDetalleAjustePK() {
        return detalleAjustePK;
    }

    public void setDetalleAjustePK(DetalleAjustePK detalleAjustePK) {
        this.detalleAjustePK = detalleAjustePK;
    }

    public int getDetalleAjusteCantidad() {
        return detalleAjusteCantidad;
    }

    public void setDetalleAjusteCantidad(int detalleAjusteCantidad) {
        this.detalleAjusteCantidad = detalleAjusteCantidad;
    }

    public BigDecimal getDetalleAjustePrecio() {
        return detalleAjustePrecio;
    }

    public void setDetalleAjustePrecio(BigDecimal detalleAjustePrecio) {
        this.detalleAjustePrecio = detalleAjustePrecio;
    }

    public String getDetalleAjusteTipo() {
        return detalleAjusteTipo;
    }

    public void setDetalleAjusteTipo(String detalleAjusteTipo) {
        this.detalleAjusteTipo = detalleAjusteTipo;
    }

    public Ajuste getAjuste() {
        return ajuste;
    }

    public void setAjuste(Ajuste ajuste) {
        this.ajuste = ajuste;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (detalleAjustePK != null ? detalleAjustePK.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DetalleAjuste)) {
            return false;
        }
        DetalleAjuste other = (DetalleAjuste) object;
        if ((this.detalleAjustePK == null && other.detalleAjustePK != null) || (this.detalleAjustePK != null && !this.detalleAjustePK.equals(other.detalleAjustePK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "dbCon.DetalleAjuste[ detalleAjustePK=" + detalleAjustePK + " ]";
    }

}
